const mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

const tools = require('../tools/general');

mongoose.Promise = global.Promise;
mongoose.level = "F";


// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const departmentSchema = new Schema({
  idapp: {
    type: String,
  },
  name: {
    type: String,
  },
  username: {
    type: String,
  },
});

var Department = module.exports = mongoose.model('Department', departmentSchema);

module.exports.createIndexes()
  .then(() => { })
  .catch((err) => { throw err; });


module.exports.getFieldsForSearch = function () {
  return [{ field: 'name', type: tools.FieldType.string },
    { field: 'username', type: tools.FieldType.string }
  ]
};

module.exports.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, idapp, params);
};

module.exports.findAllIdApp = async function (idapp) {
  const myfind = { idapp };

  return await Department.find(myfind).lean();
};

